package vzorka_riadkov;

import java.awt.Frame;
import java.awt.Image;
import java.awt.image.CropImageFilter;
import java.awt.image.FilteredImageSource;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

import javax.media.Buffer;
import javax.media.control.FrameGrabbingControl;
import javax.media.format.VideoFormat;
import javax.media.util.BufferToImage;

public class Snimky extends Frame implements Runnable{
	
	private FrameGrabbingControl grabber;
	private VideoFormat vFormat; 
	private Buffer buffer;
	private BufferToImage bToImage;
	private Image captured;
	private Platno p = new Platno()
	;
	private PrintWriter outputStream = null;
	private boolean b = true;
	private int time = 100;
	private String file;
	private Vision v = new Vision("");
		
	private GreyScaleFilter gsf = new GreyScaleFilter();
	
	/**
	 * Ziskava postupne obrazky, kt. hodnoty filtruje a uklada do suboru 
	 */
	public void run() {
		try {
			outputStream = new PrintWriter(new FileWriter(file + ".txt"));
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		v.startViewer("nothning");
    	grabber = (FrameGrabbingControl) Vision.p.getControl("javax.media.control.FrameGrabbingControl");   
	    if (grabber == null)
		{
			System.err.println("Error in Getting Grabber Control");
			System.exit(1);
		} 
		b = true;
		while(b) {
		    buffer = grabber.grabFrame();
		    vFormat = (VideoFormat) buffer.getFormat();
			bToImage = new BufferToImage(vFormat);
			
			captured = bToImage.createImage(buffer);
			
			if (captured != null) {
				int []data; 
				int height = captured.getHeight(this) / 2;
				captured = createImage(new FilteredImageSource(captured.getSource(),
				        new CropImageFilter(0, height, captured.getWidth(this), 1)));
				
				gsf.calculateGreyScale(captured, captured.getWidth(this));
				sleep(1);
				p.setImage(gsf.getImage());			
				data = gsf.getData();
				String s = "";
				for (int i = 0; i < data.length; i++) {
					s = s + data[i] + " ";
					//System.out.print(data[i] + " ");
				}
				outputStream.println(s);
				//System.out.println();
			}	
			sleep(time);
		}
		
	}
	
	public void stop() {
		b = false;
		sleep(5);
		v.stopViewer();
		if (outputStream != null) outputStream.close();
	}
	
	/**
	 * Uspi vlakno na dany cas.
	 * @param milis
	 */
	public void sleep(int milis) {
		try {
			Thread.sleep(milis);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	/**
	 * Nastavi subor, do ktoreho sa bude vystup ukladat
	 * @param s
	 */
	public void setFile(String s) {
		file = s;
	}
	
	/**
	 * Nastavi dlzku snimaneho intervalu.
	 * @param time
	 */
	public void setTime(int time) {
		this.time = time;
	}

}
