package vzorka_riadkov;

//import ine.Platno;
//import ine.Vision;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.TextField;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.awt.image.CropImageFilter;
import java.awt.image.FilteredImageSource;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

import javax.media.Buffer;
import javax.media.control.FrameGrabbingControl;
import javax.media.format.VideoFormat;
import javax.media.util.BufferToImage;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;



public class Vzorka extends JFrame implements WindowListener{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private Snimky snimky = null;
	private Thread tgrabber = null;
		
	private JButton btStart = new JButton("Start");
	private JButton btStop  = new JButton("Stop");
	private JButton btClose = new JButton("Close");
	
	private JSpinner spTime = new JSpinner();
	private JTextField tfFile = new JTextField("vystup");
	
	private JLabel lbStatus = new JLabel("nothning");
	
	private static Image img;
	
	/**
	 * konstruktor
	 *
	 */
	public Vzorka() {
		//	nastavi velkost formularu
		setSize(350,150);
		//	formular bude reagovat na udalosti
		addWindowListener(this);
		//	nastavi titulok formularu
		setTitle("Vzorka");

		center(this.getSize(), this);
			
		Container cSouth = new Container();
		Container cNorth = new Container();
		Container cCenter = new Container();
		//nastavi kontajnerom layouty
		cSouth.setLayout(new FlowLayout());
		cNorth.setLayout(new FlowLayout());
		cCenter.setLayout(new GridLayout(2,2));
		
		//	tlacidla budu reagovat na udalosti
		btStart.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				snimky = new Snimky();
				lbStatus.setText("Spracovavam data");
				snimky.setFile(tfFile.getText());
				Object o = spTime.getValue();
				if (o instanceof Integer) {
					snimky.setTime((Integer) o);
				}
				btStart.setEnabled(false);
				btClose.setEnabled(false);
				tgrabber = new Thread(snimky);
				tgrabber.start();				
			}
		});
		
		btStop.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {				
				tgrabber.stop();				
				lbStatus.setText("operacia skoncena");
				btStart.setEnabled(true);
				btClose.setEnabled(true);
			}
		});
		
		btClose.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {		
				System.exit(0);				
			}
		});

		spTime.setValue(new Integer(100));
		//	nastavi testu farbu
		lbStatus.setForeground(Color.RED);
		//	pridame kontajnerom komponenty
		cNorth.add(lbStatus);
		
		cSouth.add(btStart);
		cSouth.add(btStop);
		cSouth.add(btClose);
		
		cCenter.add(new JLabel("   Cas (ms): "));
		cCenter.add(spTime);
		cCenter.add(new JLabel("   Subor: "));
		cCenter.add(tfFile);
		//	prida do formularu kontajnery
		add(new BorderLayout().NORTH, cNorth);
		add(new BorderLayout().CENTER, cCenter);
		add(new BorderLayout().SOUTH, cSouth);
		
		//	zobrazi formular
		setVisible(true);
	}

	/**
	 * Vycentruje formular do stredu obrazovky.
	 * @param frameSize
	 * @param frame
	 */
	public static void center(Dimension frameSize, JFrame frame) {
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		if (frameSize.height > screenSize.height) {
		    frameSize.height = screenSize.height;
		}
		if (frameSize.width > screenSize.width) {
		   frameSize.width = screenSize.width;
		}
		if (frame != null) frame.setLocation((screenSize.width - frameSize.width) / 2,
				(screenSize.height - frameSize.height) / 2);
	}
	
	public void windowActivated(WindowEvent arg0) {}
	public void windowClosed(WindowEvent arg0) {}
	public void windowClosing(WindowEvent arg0) {
		System.exit(0);		
	}

	public void windowDeactivated(WindowEvent arg0) {}
	public void windowDeiconified(WindowEvent arg0) {}
	public void windowIconified(WindowEvent arg0) {}
	public void windowOpened(WindowEvent arg0) {}
	
	/**
	 * Vytvori referenciu na dany obrazok.
	 * @param image
	 */
	public static void setImage(Image image) {
		img = image;
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		new Vzorka();
	}
	
}
